if(!("WebSocket" in this))
{
  // When the WebSocket() constructor is invoked, the UA must run these steps:
  this.WebSocket=function(url,protocol)
  {
    // Parse a Web Socket URL's components from the url argument, to obtain host, port, resource name, and secure. If this fails, throw a SYNTAX_ERR exception and abort these steps.
    if(!/^wss?:\/\//.test(url))
      throw new SyntaxError("[WebSocket] Invalid URL '"+url+"'");
      
    this.URL=url;
    this.readyState=0;
    
    this.onopen=null;
    this.onmessage=null;
    this.onclose=null;
    
    this.instId_=this.instMap_.nextId++;
    this.instMap_[this.instId_]=this;
    
    this.__open();
  };
  
  WebSocket.prototype.instMap_={nextId:0};
  WebSocket.prototype.pendingSockets_=[];
  
  WebSocket.prototype.isFlashAvailable__=null;
  WebSocket.prototype.flashMovie_=null;
  
  WebSocket.prototype.bufferedAmount=0;


  WebSocket.CONNECTING=0;
  WebSocket.OPEN=1;
  WebSocket.CLOSED=2;
 
  
  /*
  WebSocket.prototype.__throw=function(code,msg)
  {
    var error = new Error(msg);
    
    error.code = code;
    error.name = "DOMException";
    
    throw error;
  };
  */
  
  WebSocket.prototype.send=function(data)
  {
    if(this.readyState !== 1)
    {
      var error = new Error(msg);
    
      error.code = DOMException.INVALID_STATE_ERR;
      error.name = "DOMException";
      error.constructor=DOMException;
      
      throw error;
    }
      
    this.flashMovie_.send(this.wsId_,""+data);
    
    return true;
  };
  WebSocket.prototype.close=function()
  {
    if(this.readyState === 2)
      return;
      
    this.flashMovie_.close(this.wsId_);  
  };
  
  (function()
  {
    var callArgsQueue=[];
    var _dispatch=function()
    {
      var args=callArgsQueue.shift();
      
      WebSocket.prototype[args[0]].call(WebSocket.prototype.instMap_[args[1]],args);
    };

    WebSocket.prototype.__dispatchFlashEvent=function()
    {
      callArgsQueue.push(Array.prototype.slice.call(arguments,0,arguments.length));
      setTimeout(_dispatch,0);
    };
  })();
  
  WebSocket.prototype.__open=function()
  {
    if(this.isFlashAvailable__ === false)
      throw new Error("Flash unavailable");
    
    if(this.flashMovie_==null)
      return this.pendingSockets_.push(this);
      
    this.wsId_=this.flashMovie_.create();
    this.flashMovie_.open(this.wsId_,this.URL);
  };
  
  WebSocket.prototype.__openPendingSockets=function()
  {
    var pss=this.pendingSockets_,i=pss.length;
    
    while(i--)
      pss[i].__open();

    delete this.pendingSockets_;
  };
  WebSocket.prototype.__discardPendingSockets=function()
  {
    var pss=this.pendingSockets_,i=pss.length;
    
    while(i--)
    {
      var s=pss[i];
      
      s.readyState=1;
      
      if(s.onopen!=null)
        s.onopen({});

      s.readyState=2;
      
      if(s.onclose!=null)
        s.onclose({});
    }

    delete this.pendingSockets_;
  };
  
  
  WebSocket.prototype.__flashInited=function()
  {
    this.flashMovie_=document.getElementById("y8-websocket-flash-js");
    this.isFlashAvailable__=true;
    this.__openPendingSockets();
  };
  WebSocket.prototype.__flashInitFailed=function()
  {
    this.isFlashAvailable__=false;
    this.__discardPendingSockets();
  };
  
  WebSocket.prototype.__flashWSOpened=function(funcName,id)
  {
    var s=this.instMap_[id];
    
    s.readyState=1;
    
    if(s.onopen!=null)
      s.onopen({});
  };
  
  WebSocket.prototype.__flashWSMessageReceived=function(funcName,id,data)
  {
    var s=this.instMap_[id];

    if(s.onmessage!=null)
      s.onmessage({data:data});
  };
  WebSocket.prototype.__flashWSClosed=function(funcName,id)
  {
    var s=this.instMap_[id];

    s.readyState=2;
    
    if(s.onclose!=null)
      s.onclose({});
  };
  WebSocket.prototype.__flashWSError=function(funcName,id)
  {
    var s=this.instMap_[id];

    s.readyState=2;
    
    if(s.onclose!=null)
      s.onclose({});
  };
  WebSocket.prototype.__dispatchFlashEvent=function(funcName)
  {
    var a=Array.prototype.slice.call(arguments,0);
    
    setTimeout(function(){ WebSocket.prototype[funcName].apply(null, a); },0);
  };

  WebSocket.prototype.flashMovieUrl="WebSocketFlash.swf"; // default path;
  // WebSocket.prototype.flashMovieUrl="/p/jbasis/src/_3rdParty/websocket-flash-js/src/WebSocketFlash.swf"; // bga s work path;
  
  swfobject.addDomLoadEvent(
    function()
    {
      document.body.appendChild(document.createElement('span')).id='y8-websocket-flash-js';
      
      swfobject.embedSWF(
        WebSocket.prototype.flashMovieUrl, 
        "y8-websocket-flash-js", 
        100, // width  
        100, // height
        "9.0.0", // ver
        null, // expressInstall
        null, // flashvars 
        null, // params 
        null, // attributes
        function(obj) // callback
        {
          if(!obj || !obj.success)
            WebSocket.prototype.__flashInitFailed();
        }
      );
    }
  );
}